<?

// Developpeur : gusdelamort pour forum.eedomus.com
// Version : 2.3
// Objectif : Sortir une localisation entre deux points
// Code adapté du développeur Julien (alias CMoi20 sur le forum de TLD) => MERCI a LUI

// Option : &xmldemande=oui -> permet de sortir la distance
// <distance></distance>

function get_distance_m($lat1, $lng1, $lat2, $lng2) 
{
  $earth_radius = 6378137;   // Terre = sphere de 6378km de rayon
  $rlo1 = deg2rad($lng1);
  $rla1 = deg2rad($lat1);
  $rlo2 = deg2rad($lng2);
  $rla2 = deg2rad($lat2);
  $dlo = ($rlo2 - $rlo1) / 2;
  $dla = ($rla2 - $rla1) / 2;
  $a = (sin($dla) * sin($dla)) + cos($rla1) * cos($rla2) * (sin($dlo) * sin($dlo
));
  $d = 2 * atan2(sqrt($a), sqrt(1 - $a));
  return ($earth_radius * $d);
}

function get_iPhone_location($periphname, $user, $pass) 
{
$ch = curl_init();
$header[] = 'Content-Type: application/json; charset=utf-8';
$header[] = 'X-Apple-Find-Api-Ver: 2.0';
$header[] = 'X-Apple-Authscheme: UserIdGuest';
$header[] = 'X-Apple-Realm-Support: 1.0';
$header[] = 'User-agent: Find iPhone/1.3 MeKit (iPad: iPhone OS/4.2.1)';
$header[] = 'X-Client-Name: iPad';
$header[] = 'X-Client-UUID: 0cf3dc501ff812adb0b202baed4f37274b210853';
$header[] = 'Accept-Language: en-us';
$header[] = 'Connection: keep-alive';
curl_setopt($ch, CURLOPT_URL, 'https://fmipmobile.icloud.com/fmipservice/device/'.$user.'/initClient');
curl_setopt($ch, CURLOPT_USERPWD, $user.':'.$pass);
curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
curl_setopt($ch, CURLOPT_HEADER, TRUE);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
curl_setopt($ch, CURLOPT_USERAGENT, 'Find iPhone/1.3 MeKit (iPad: iPhone OS/4.2.1)');
curl_setopt($ch, CURLOPT_AUTOREFERER, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
$value = curl_exec($ch);
curl_close($ch);
$lines = explode("\n",$value);
foreach($lines as $line) {
if(substr($line,0,17) == "X-Apple-MMe-Host:") {
$server = substr($line,18,-1);
}
}
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, "https://".$server."/fmipservice/device/".$user."/initClient");
curl_setopt($ch, CURLOPT_USERPWD, $user.':'.$pass);
curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
curl_setopt($ch, CURLOPT_HEADER, FALSE);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
curl_setopt($ch, CURLOPT_USERAGENT, 'Find iPhone/1.3 MeKit (iPad: iPhone OS/4.2.1)');
curl_setopt($ch, CURLOPT_AUTOREFERER, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_COOKIE, $cookie);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
$value = curl_exec($ch);
curl_close($ch);
//print $value;

$json = json_decode($value);
$valuearray = (array)$json;
foreach($valuearray['content'] as $periph) {
$periphvalue = (array)$periph;
if($periphvalue['name'] == $periphname) {
$location = (array)$periphvalue['location'];
return $location;
}
}
}

include 'compteetconnexion.php';
$xmldemande = $_GET["xmldemande"];

if ($xmldemande == 'oui')
{
 	// on se connecte à MySQL
	$db= mysql_connect($ipserveurbdd,$compte,$password) or die("Impossible de se connecter : " . mysql_error());
	// on sélectionne la base
	$db_selected = mysql_select_db($base,$db);
	if (!$db_selected) 
	{
	   die ('Impossible de sélectionner la base de données : ' . mysql_error());
	}   
	$derniereposition= "SELECT * FROM `Gps` ORDER BY `index` DESC LIMIT 1";
	$resultgps = mysql_query($derniereposition);
	while($resultat = mysql_fetch_row($resultgps)) 
	{ 
	  $distanceavecmaison = $resultat[4];
	  $datecorrigee = $resultat[1];
	  $lat = $resultat[2];
	  $long = $resultat[3];
	}
	
	$xml = '<?xml version="1.0" encoding="UTF-8"?>';
	$xml .= '<list>';
	$xml .= '<distance>';
	$xml .= $distanceavecmaison;
	$xml .= '</distance>';
	$xml .= '<lat>';
	$xml .= $lat;
	$xml .= '</lat>';
	$xml .= '<long>';
	$xml .= $long;
	$xml .= '</long>';
	$xml .= '<datetime>';
	$xml .= $datecorrigee;
	$xml .= '</datetime>';
	$xml .= '</list>';
	echo $xml;
}
else
{
	$location = get_iPhone_location($iphonenom,$clouduser,$cloudpass);
	$distanceavecmaison = get_distance_m($latitudemaison, $longitudemaison , $location['latitude'], $location['longitude']);
	$date = $location['timeStamp'];
	$datecorrigee = substr($date,0,10); 
	$distanceavecmaison = round($distanceavecmaison,0);
	
	$datebdd=date('Y-m-d H:i:s',$datecorrigee);
	$datecorrigee= date('d/m/Y H:i:s',$datecorrigee);
	/*
	print "<center>Le ";
	print $datecorrigee;
	print " la distance entre votre device et votre maison est de ";
	print $distanceavecmaison;
	print ' metres';
	*/
	// on se connecte à MySQL
	$db= mysql_connect($ipserveurbdd,$compte,$password) or die("Impossible de se connecter : " . mysql_error());

	// on sélectionne la base
	$db_selected = mysql_select_db($base,$db);
	
	$ajouttable = "CREATE TABLE IF NOT EXISTS `Gps` (`index` int(11) NOT NULL AUTO_INCREMENT,`date` datetime NOT NULL,`latitude` varchar(255) NOT NULL,`longitude` varchar(255) NOT NULL,`distancemaison` int(11) NOT NULL,PRIMARY KEY (`index`)) ENGINE=MyISAM  DEFAULT CHARSET=latin1;";
    mysql_query ($ajouttable);
	
	if (!$db_selected) 
	{
	   die ('Impossible de sélectionner la base de données : ' . mysql_error());
	}
	$lat = $location['latitude'];
	$long = $location['longitude'];
	$ajout = "INSERT INTO $base.Gps VALUES (NULL,'$datebdd','$lat','$long','$distanceavecmaison')";
	mysql_query ($ajout);
}
?>